//
// vector1.cpp
// Testing <vector>
// push_back(), size(), capacity(), max_size(), reserve(), resize()
// Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include "stdafx.h"
#include <vector>
#include <iomanip>
#include <iostream>

using namespace std ;

typedef vector<int> iVector;

int main(int argc, char* argv[])
{
    // Instantiation of 0 element integer vector.
    iVector iVectorInstance;

    // Inserting a 5, at the end of the vector
    iVectorInstance.push_back(5);

    // Current vector statistics.
    cout << "Current statistics:" << endl;
    cout << "iVectorInstance's current size: " 
	     <<  setw(10) << iVectorInstance.size() << endl;
    cout << "iVectorInstance's maximum size: " 
	     <<  iVectorInstance.max_size() << endl;
    cout << "iVectorInstance's capacity    : " 
	     <<  setw(10) << iVectorInstance.capacity() << endl;

    // See if there is room for a total of 15 elements
    iVectorInstance.reserve(15);
    cout << "\nReserving storage for 15 elements:" << endl;
    cout << "iVectorInstance's size is     : " 
	     <<  setw(10) << iVectorInstance.size() << endl;
    cout << "iVectorInstance's maximum size: " 
	     <<  setw(10) << iVectorInstance.max_size() << endl;
    cout << "iVectorInstance's capacity is : " 
	     <<  setw(10) << iVectorInstance.capacity() << endl;

    // Demanding room for at least 25 elements.
    iVectorInstance.resize(25);
    cout << "\nAfter resizing storage for 25 elements:"
         << endl;
    cout << "iVectorInstance's size is     : " 
	     <<  setw(10) << iVectorInstance.size() << endl;
    cout << "iVectorInstance's maximum size: " 
	     <<  iVectorInstance.max_size() << endl;
    cout << "iVectorInstance's capacity is : " 
	     <<  setw(10) << iVectorInstance.capacity() << endl;

    cout << endl << endl;

    return 0;
}
