//
// vector2.cpp
// Testing <vector>
// push_back(), insert(), delete(), begin(), end()
// Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include "stdafx.h"
#include <vector>
#include <iostream>

using namespace std ;

typedef vector<char> cVector;

int main(int argc, char* argv[])
{
    // Instantiation of 0 element integer vector.
    cVector cVectorInstance;

    // Inserting five vowels
	cVectorInstance.push_back('A');
	cVectorInstance.push_back('E');
	cVectorInstance.push_back('I');
	cVectorInstance.push_back('O');
	cVectorInstance.push_back('Y');

	// Accessing vector elements using array syntax - DANGEROUS
	for(int i = 0; i < 5; i++)
	  cout << cVectorInstance[i];
	cout << endl;

	// Accessing vector elements using iterators - BEST APPROACH
	vector<char>::iterator p = cVectorInstance.begin();
	while(p != cVectorInstance.end()) {
	  cout << *p;
	  p++;
	}
    cout << endl;

	// Inserting a NEW fifth element extending the vector's size
	p = cVectorInstance.begin();
	p += 4; // moves pointer to fifth element's address
	cVectorInstance.insert(p, 'U');

    // Accessing the NEW list
	p = cVectorInstance.begin();
	while(p != cVectorInstance.end()) {
	  cout << *p;
	  p++;
	}
	cout << endl;

	// Deleting the sixth element 'Y'
	p = cVectorInstance.end();
	cVectorInstance.erase(--p);

    // Printing the modified container
	p = cVectorInstance.begin();
	while(p != cVectorInstance.end()) {
	  cout << *p;
	  p++;
	}

    cout << endl << endl;

    return 0;
}
